<template>
    <f7-page 
        name="documentdetail" 
        @page:beforein="onPageBeforeIn">

        <!-- Top Navbar -->
		<f7-navbar :sliding="false">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title>{{ document != null ? document.title : 'Loading' }}</f7-nav-title>
		</f7-navbar>

        <f7-block strong inset v-if="document != null">
            <f7-row>
                <f7-col width="35">
                    <qrcode :value="document.tracking_number" :options="{ width: 100 }"></qrcode>
                </f7-col>
                <f7-col width="65">
                    <small class="display-block margin-small-top">Tracking Number</small>
                    <h4 class="no-margin-top margin-small-bottom">{{ document.tracking_number }}</h4>
                    <small>Document Number</small>
                    <h4 class="no-margin-top">{{ document.document_number }}</h4>
                </f7-col>
            </f7-row>

            <f7-row>
                <f7-col>
                    <small class="font-bold">Title</small>
                    <p class="no-margin-top">{{ document.title }}</p>
                </f7-col>
            </f7-row>
            <f7-row>
                <f7-col>
                    <small class="font-bold">Remarks</small>
                    <p class="no-margin-top">{{ document.remarks }}</p>
                </f7-col>
            </f7-row>
            <f7-row>
                <f7-col>
                    <small class="font-bold">Author</small>
                    <p class="no-margin-top">{{ document.author.fullname }}, {{ document.author.organization.name.capitalize() }}</p>
                </f7-col>
            </f7-row>
        </f7-block>
        <f7-block strong inset v-if="document != null && document.person_involves.length > 0">
            <h4>Person Involves</h4>
            <f7-list media-list no-hairlines>
                <f7-list-item
                    v-for="(person, index) in document.person_involves"
                    :key="index"
                    :title="person.fullname.capitalize()"
                    :after="person.phone">
                        <f7-icon slot="media" material="person_outline"></f7-icon>
                </f7-list-item>
            </f7-list>
        </f7-block>
        <f7-block strong inset v-if="document != null && document.statuses.length > 0">
            <h4>Status</h4>
            <ul class="timeline">
                <li 
                    class="timeline-item"
                    v-for="(status, index) in document.statuses"
                    :key="index"
                    >
                    <div class="timeline-item-tail"></div>
                    <div class="timeline-item-node timeline-item-node-normal"></div>
                    <div class="timeline-item-wrapper">
                        <div class="timeline-timestamp">{{ dateFormat(status.created) }}</div>
                        <div class="timeline-item-content">
                            <h4 class="no-margin-bottom">{{ status.status.name }} <f7-icon v-if="status.notified" material="notifications_none"></f7-icon> </h4>
                            <small class="display-block">Updated By: {{ status.author.fullname }}</small>
                            <span class="display-block margin-small-top">{{ status.note }}</span>
                        </div>
                    </div>
                </li>
            </ul>
        </f7-block>
        <f7-block strong inset v-if="document != null && document.medias.length > 0">
            <h4>Attachments</h4>
            <f7-list media-list no-hairlines>
                <f7-list-item
                    v-for="(media, index) in document.medias"
                    :key="index"
                    :title="media.original_filename"
                    :subtitle="bytesToSize(media.size) + ' - ' + dateFormat(media.updated)"
                    @click="handleDownload(media)">
                        <f7-icon slot="media" material="attach_file"></f7-icon>
                </f7-list-item>
            </f7-list>
        </f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { parseError, dateFormat, convertAmpersand, bytesToSize } from '../js/utils';
export default {
    name: 'DocumentDetail',
    data(){
        return {
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('document', ['document'])
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
    },
    methods: {
        dateFormat,
        convertAmpersand,
        bytesToSize,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            app.preloader.show('blue');

            self.$store.dispatch('document/viewDocument', {
                id: self.$f7route.params.id
            }).then(()=>{
                app.preloader.hide();
            });
        },
        handleDownload(media){
            const self = this;
            const app = self.$f7;

            var a = document.createElement("a");
            a.href = media.url.original;
            a.setAttribute("download", media.original_filename);
            a.click();
        }
    },

}
</script>